Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_SPIPE_Stream Class Reference

Define an ACE_SPIPE_Stream. More...

`#include <SPIPE_Stream.h>`

Inheritance diagram for ACE_SPIPE_Stream

[legend]
Collaboration diagram for ACE_SPIPE_Stream:

[legend]
List of all members.

## Public Types
typedef ACE_SPIPE_Addr | PEER_ADDR
## Public Methods
| ACE_SPIPE_Stream (void)
| Default constructor.
int | get_remote_addr (ACE_SPIPE_Addr &remote_sap) const
| Obtain the address of whom we are connected with.
int | send_handle (ACE_HANDLE handle) const
| Send an open FD to another process.
int | recv_handle (ACE_HANDLE &handle) const
| Recv an open FD from another process.
int | recv_handle (strrecvfd &recvfd) const
| Recv an open FD from another process.
ssize_t | send_n (const void *buf, size_t n) const
| Send n bytes, keep trying until n are sent.
ssize_t | recv_n (void *buf, size_t n) const
| Recv n bytes, keep trying until n are received.
ssize_t | send (const void *buf, size_t n) const
| Send bytes via STREAM pipes using "band" mode.
ssize_t | recv (void *buf, size_t n) const
| Recv bytes via STREAM pipes using "band" mode.
ssize_t | send (const ACE_Str_Buf *cntl, const ACE_Str_Buf *data, int flags = 0) const
| Send <cntl> and <data> via STREAM pipes.
ssize_t | recv (ACE_Str_Buf *cntl, ACE_Str_Buf *data, int *flags) const
| Recv <cntl> and <data> via STREAM pipes.
ssize_t | send (const ACE_Str_Buf *cntl, const ACE_Str_Buf *data, int band, int flags) const
| Send bytes via STREAM pipes using "band" mode.
ssize_t | recv (ACE_Str_Buf *cntl, ACE_Str_Buf *data, int *band, int *flags) const
| Recv bytes via STREAM pipes using "band" mode.
ssize_t | send (const iovec iov[], size_t n) const
| Send iovecs via <writev>.
ssize_t | recv (iovec iov[], size_t n) const
| Recv iovecs via <readv>.
ssize_t | send (size_t n, ...) const
ssize_t | recv (size_t n, ...) const
ssize_t | send (const void *buf, size_t n, ACE_OVERLAPPED *overlapped) const
| Send <n> bytes via Win32 WriteFile using overlapped I/O.
ssize_t | recv (void *buf, size_t n, ACE_OVERLAPPED *overlapped) const
| Recv <n> bytes via Win32 ReadFile using overlapped I/O.
ssize_t | sendv (const iovec iov[], size_t n) const
| Send an <iovec> of size <n> to the stream.
ssize_t | sendv_n (const iovec iov[], size_t n) const
| Send an <iovec> of size <n> to the stream. Will block until all bytes are sent or an error occurs.
ssize_t | recvv_n (iovec iov[], size_t n) const
| Receive an <iovec> of size <n> to the stream.
void | dump (void) const
| Dump the state of an object.
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks.
## Private Attributes
ACE_SPIPE_Addr | remote_addr_
## Friends
class | ACE_SPIPE_Acceptor
class | ACE_SPIPE_Connector

## Detailed Description

Define an ACE_SPIPE_Stream.

## Member Typedef Documentation

typedef ACE_SPIPE_Addr ACE_SPIPE_Stream::PEER_ADDR

## Constructor & Destructor Documentation

ACE_SPIPE_Stream::ACE_SPIPE_Stream ( | void )

| Default constructor.

## Member Function Documentation

void ACE_SPIPE_Stream::dump ( | void ) const

| Dump the state of an object. Reimplemented from ACE_SPIPE.

ASYS_INLINE int ACE_SPIPE_Stream::get_remote_addr ( | ACE_SPIPE_Addr & remote_sap ) const

| Obtain the address of whom we are connected with.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recv ( | void * buf,
| size_t n,
| ACE_OVERLAPPED * overlapped ) const

| Recv <n> bytes via Win32 ReadFile using overlapped I/O.

ssize_t ACE_SPIPE_Stream::recv ( | size_t n,
| ... ) const

| This is an interface to readv, that doesn't use the struct iovec explicitly. The ... can be passed as an arbitrary number of (char *ptr, int len) tuples. However, the count N is the *total* number of trailing arguments, *not* a couple of the number of tuple pairs!

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recv ( | iovec iov[],
| size_t n ) const

| Recv iovecs via <readv>.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recv ( | ACE_Str_Buf * cntl,
| ACE_Str_Buf * data,
| int * band,
| int * flags ) const

| Recv bytes via STREAM pipes using "band" mode.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recv ( | ACE_Str_Buf * cntl,
| ACE_Str_Buf * data,
| int * flags ) const

| Recv <cntl> and <data> via STREAM pipes.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recv ( | void * buf,
| size_t n ) const

| Recv bytes via STREAM pipes using "band" mode.

ASYS_INLINE int ACE_SPIPE_Stream::recv_handle ( | strrecvfd & recvfd ) const

| Recv an open FD from another process.

ASYS_INLINE int ACE_SPIPE_Stream::recv_handle ( | ACE_HANDLE & handle ) const

| Recv an open FD from another process.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recv_n ( | void * buf,
| size_t n ) const

| Recv n bytes, keep trying until n are received.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::recvv_n ( | iovec iov[],
| size_t n ) const

| Receive an <iovec> of size <n> to the stream.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::send ( | const void * buf,
| size_t n,
| ACE_OVERLAPPED * overlapped ) const

| Send <n> bytes via Win32 WriteFile using overlapped I/O.

ssize_t ACE_SPIPE_Stream::send ( | size_t n,
| ... ) const

| Send N char *ptrs and int lengths. Note that the char *'s precede the ints (basically, an varargs version of writev). The count N is the *total* number of trailing arguments, *not* a couple of the number of tuple pairs!

ASYS_INLINE ssize_t ACE_SPIPE_Stream::send ( | const iovec iov[],
| size_t n ) const

| Send iovecs via <writev>.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::send ( | const ACE_Str_Buf * cntl,
| const ACE_Str_Buf * data,
| int band,
| int flags ) const

| Send bytes via STREAM pipes using "band" mode.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::send ( | const ACE_Str_Buf * cntl,
| const ACE_Str_Buf * data,
| int flags = 0 ) const

| Send <cntl> and <data> via STREAM pipes.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::send ( | const void * buf,
| size_t n ) const

| Send bytes via STREAM pipes using "band" mode.

ASYS_INLINE int ACE_SPIPE_Stream::send_handle ( | ACE_HANDLE handle ) const

| Send an open FD to another process.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::send_n ( | const void * buf,
| size_t n ) const

| Send n bytes, keep trying until n are sent.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::sendv ( | const iovec iov[],
| size_t n ) const

| Send an <iovec> of size <n> to the stream.

ASYS_INLINE ssize_t ACE_SPIPE_Stream::sendv_n ( | const iovec iov[],
| size_t n ) const

| Send an <iovec> of size <n> to the stream. Will block until all bytes are sent or an error occurs.

## Friends And Related Function Documentation

class ACE_SPIPE_Acceptor`[friend]`

class ACE_SPIPE_Connector`[friend]`

## Member Data Documentation

ACE_SPIPE_Stream::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks. Reimplemented from ACE_SPIPE.

ACE_SPIPE_Addr ACE_SPIPE_Stream::remote_addr_`[private]`

The documentation for this class was generated from the following files:

- SPIPE_Stream.h
- SPIPE_Stream.cpp
- SPIPE_Stream.i